/* Copyright 2001 TransGaming Technologies, Inc. */
#ifndef WINE_DDRAW_DDRAW_GL_H_INCLUDED
#define WINE_DDRAW_DDRAW_GL_H_INCLUDED

#include <wine_gl.h>

/* see http://oss.sgi.com/projects/ogl-sample/registry/ */
#define DD_GL_EXTENSION_LIST \
  DD_GL_EXT(ARB_multitexture), \
  DD_GL_EXT(ARB_transpose_matrix), \
  DD_GL_EXT(ARB_multisample), \
  DD_GL_EXT(ARB_texture_env_add), \
  DD_GL_EXT(ARB_texture_cube_map), \
  DD_GL_EXT(ARB_texture_compression), \
  DD_GL_EXT(ARB_texture_border_clamp), \
  DD_GL_EXT(ARB_point_parameters), \
  DD_GL_EXT(ARB_vertex_blend), \
  DD_GL_EXT(ARB_matrix_palette), \
  DD_GL_EXT(ARB_texture_env_combine), \
  DD_GL_EXT(ARB_texture_env_crossbar), \
  DD_GL_EXT(ARB_texture_env_dot3), \
  /* out of ARB extensions... what EXT extensions might also be useful? */ \
  DD_GL_EXT(EXT_clip_volume_hint),		/* 79 */ \
  DD_GL_EXT(EXT_compiled_vertex_array),		/* 97 */ \
  DD_GL_EXT(EXT_secondary_color),		/* 145 */ \
  DD_GL_EXT(EXT_fog_coord),			/* 149 */ \
  DD_GL_EXT(EXT_texture_env_combine),		/* 158 */ \
  DD_GL_EXT(EXT_blend_func_separate),		/* 173 */ \
  DD_GL_EXT(EXT_stencil_wrap),			/* 176 */ \
  DD_GL_EXT(EXT_texture_env_add),		/* 185 */ \
  DD_GL_EXT(EXT_texture_lod_bias),		/* 186 */ \
  DD_GL_EXT(EXT_texture_filter_anisotropic),	/* 187 */ \
  DD_GL_EXT(EXT_vertex_weighting),		/* 188 */ \
  DD_GL_EXT(EXT_texture_compression_s3tc),	/* 198 */ \
  DD_GL_EXT(EXT_texture_env_dot3),		/* 220 */ \
  /* out of EXT extensions... */ \
  DD_GL_EXT(NV_texgen_reflection),		/* 179 */ \
  DD_GL_EXT(NV_vertex_array_range),		/* 190 */ \
  DD_GL_EXT(NV_blend_square),			/* 194 */ \
  DD_GL_EXT(NV_texture_env_combine4),		/* 195 */ \
  DD_GL_EXT(NV_fence),				/* 222 */ \
  DD_GL_EXT(IBM_texture_mirrored_repeat),	/* 224 */ \
  DD_GL_EXT(NV_texture_shader),			/* 230 */ \
  DD_GL_EXT(S3_s3tc)

#define DD_GL_EXT(x) x
typedef enum {
  DD_GL_EXTENSION_LIST,
  DD_GL_EXTENSION_COUNT
} DD_GL_ext;
#undef DD_GL_EXT

#define DD_GL_PROC_LIST \
  DD_GL_PROC(PFNGLACTIVETEXTUREARBPROC,glActiveTextureARB) \
  DD_GL_PROC(PFNGLCLIENTACTIVETEXTUREARBPROC,glClientActiveTextureARB) \
  DD_GL_PROC(PFNGLMULTITEXCOORD2FARBPROC,glMultiTexCoord2fARB) \
  DD_GL_PROC(PFNGLSECONDARYCOLOR3UBEXTPROC,glSecondaryColor3ubEXT) \
  DD_GL_PROC(PFNGLSECONDARYCOLORPOINTEREXTPROC,glSecondaryColorPointerEXT) \
  DD_GL_PROC(PFNGLCOMPRESSEDTEXIMAGE2DARBPROC,glCompressedTexImage2DARB) \
  DD_GL_PROC(PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC,glCompressedTexSubImage2DARB)

#define DD_GL_PROC(x,y) x y;
typedef struct _DD_GL_data {
  char gl_ext[DD_GL_EXTENSION_COUNT];
  DD_GL_PROC_LIST
} DD_GL_data;
#undef DD_GL_PROC

#endif
